-- Player Singleton. (( the only difference between this and a class is we only need 1))

--Animation Textures
	local idleSheet 	= lg.newImage("idle.png")
	local walkSheet 	= lg.newImage("walk.png")
	local crouchSheet 	= lg.newImage("crouch.png")	
	local grabSheet 	= lg.newImage("grab.png")	
	local jumpSheet 	= lg.newImage("jump.png")	
	local landSheet 	= lg.newImage("land.png")	
	local kickSheet 	= lg.newImage("kick.png")	
	local slamSheet 	= lg.newImage("slam.png")	
	
--Define Animations
	local xanIdle 	= newAnimation( idleSheet, 128, 128, 0.1, 0)
	local xanWalk 	= newAnimation( walkSheet, 150, 128, 0.1, 7)
	local xanCrouch = newAnimation( crouchSheet, 128, 128, 0.2, 0)
	local xanGrab 	= newAnimation( grabSheet, 150, 150, 0.1, 0)
	local xanJump 	= newAnimation( jumpSheet, 128, 180, 0.15, 0)
	local xanLand 	= newAnimation( landSheet, 128, 180, 0.15, 4)
	local xanKick 	= newAnimation( kickSheet, 256, 128, 0.06, 0)
	local xanSlam 	= newAnimation( slamSheet, 128, 128, 0.1, 0)

	-- modify default animation modes 
	xanKick:setMode("bounce")
	



xan = {} --saftey container for XAN. 
	

xan = {     
		x = lg.getWidth()/5 , -- based on screen size start on the left 
		y = lg.getHeight()/2,
				
		drawVars = {				
				rot= 0, -- draw vars
				sx = 1,
				sy = 1,
				xo = 64,
				yo = 115,
				   },
		
		speed= 6, -- default 190 --Config Vars (speed == velX, jspd = velY .... REMEMBR IT!
		jspd = 0, -- to be incremented by accel. and decremented by gravity. 
		aspd = 10, -- airspeed
		str = 1, -- starting Strength
		jsmx = 20, -- the maximum speed of jumps
		jhgt = 350,
		jacl = 5,
		
		state = "idle", --Default States
		facing = "right",
		strength = 1, -- has to be equal to weight of rocks to lift
		
		grab = false, -- is grabbing
		jump = false, -- is jumping
		slam = false, -- is slamming 
		kick = false, -- is kicking 
		
		canJump = true, -- Xan can only jump when his feet are on the ground.
		canSlam = true,
		canMove = true,
		canKick = true, -- default vaules for abilities. 
		canFlip = true, -- can the player flip from side to side? 
		
		sideBlock = false, -- is the player blocked on the sides. 
		footBlock = false, -- is the player standing on something?
		headBlock = false, -- is there something on the players head. If it's too heavy you have to break out of the trap. 
		mouseBlock = false, -- is the player pointing to where xan should stop ?

	}

function xan:update(dt)

	xan:checkCollision()
	xan:checkState(dt) -- includes inputs
	
	-- tighten up the numbers 
	local rx = math.ceil(xan.x)
	local ry = math.ceil(xan.y)
		
	xan.x = rx
	xan.y = ry 

end 

function xan:draw() -- changes the animation depending on the state. 
	
	lg.setColor(255, 255, 255, 255)
	
	if xan.state == "crouch" then
		xanCrouch:draw(xan.x, xan.y, xan.drawVars.rot, 
					 xan.drawVars.sx, xan.drawVars.sy, xan.drawVars.xo, xan.drawVars.yo)
	end
	
	if xan.state == "grab" then
		xanGrab:draw(xan.x, xan.y, xan.drawVars.rot, 
					 xan.drawVars.sx, xan.drawVars.sy, xan.drawVars.xo, xan.drawVars.yo)
	end
	
	if xan.state == "idle" then    --- this section actually is working with the animation switches. 
		xanIdle:draw(xan.x, xan.y, xan.drawVars.rot, 
					 xan.drawVars.sx, xan.drawVars.sy, xan.drawVars.xo, xan.drawVars.yo)
	end
	
	if xan.state == "walk" then
		xanWalk:draw(xan.x, xan.y, xan.drawVars.rot, 
					 xan.drawVars.sx, xan.drawVars.sy, xan.drawVars.xo, xan.drawVars.yo)
	end

	if xan.state == "jump" then
		xanJump:draw(xan.x, xan.y, xan.drawVars.rot, 
					 xan.drawVars.sx, xan.drawVars.sy, xan.drawVars.xo, xan.drawVars.yo + 30)
	end	
	
	if xan.state == "land" then
		xanLand:draw(xan.x, xan.y, xan.drawVars.rot, 
					 xan.drawVars.sx, xan.drawVars.sy, xan.drawVars.xo, xan.drawVars.yo + 30) -- adjust for image size 
	end
	
	if xan.state == "kick" then
		xanKick:draw(xan.x, xan.y, xan.drawVars.rot, 
					 xan.drawVars.sx, xan.drawVars.sy, xan.drawVars.xo, xan.drawVars.yo ) -- adjust for image size 
	end
	
	if xan.state == "slam" then
		xanSlam:draw(xan.x, xan.y, xan.drawVars.rot, 
					 xan.drawVars.sx, xan.drawVars.sy, xan.drawVars.xo, xan.drawVars.yo ) -- adjust for image size 
	end

	
	--debug to show origin
	love.graphics.circle("fill", xan.x, xan.y, 5)
	love.graphics.circle("fill",xan.x + xan.drawVars.xo, xan.y - 64, 5)
	love.graphics.circle("fill",xan.x - xan.drawVars.xo, xan.y - 64, 5)
	
end 

-- also seems to check input. 
function xan:checkState(dt)


	
--InputStateSwitch
	if love.mouse.isDown('r') and love.mouse.isDown('l') and xan.canSlam then 
	
		xan.Slam()--rocks[i]
		
	elseif xan.footBlock 
		and xan.y <= my
		and love.mouse.isDown('r') then 
	
		xan.Kick()
		
	elseif love.mouse.isDown('l') then 
	
		xan.Jump()
		
	elseif love.mouse.isDown('r') 
		and xan.state == "idle"  then
	
		xan.Grab()
		
	elseif xan.footBlock 
		and xan.sideBlock == false 
		and xan.kick == false 
		and xan.mouseBlock == false then
		
		xan.Walk()
	
	end
	
 -- Decrease jump speed ( really looking to make a curve )  	
	if xan.state == "land" then 
		xan.jspd = (xan.jspd - xan.jacl) 
		if xan.jspd <= 0   then
			xan.jspd = 0
		end
		xan.x = xan.x + (xan.jspd * xan.drawVars.sx) *dt 
	end 
	
-- cond. for Crouch
	if xan.y < my and xan.state == "idle" then
			xan.Crouch() 
	end
	
-- Update DrawScale ( This also sends rocks flying and moves player )
	if xan.canFlip then 
	
		if xan.x > mx then 
		
			xan.drawVars.sx = -1  
			xan.facing = "left"
			
		elseif xan.x < mx then 
		
			xan.drawVars.sx = 1
			xan.facing = "right"
			
		end
		
	end

		
-- Animation Switch
	if xan.state == "idle" then 
	
		xanIdle:update(dt) 
		
	elseif xan.state == "walk" then
	
		xanWalk:update(dt) 
		
	elseif xan.state == "crouch" then
	
		xanCrouch:update(dt) 
		
	elseif xan.state == "grab" then
	
		xanGrab:update(dt) 
		
	elseif xan.state == "jump" then
	
		xanJump:update(dt) 
		
	elseif xan.state == "kick" then
	
		xanKick:update(dt) 
		
	elseif xan.state == "land" then
	
		xanLand:update(dt) 
		
	end


end 

function xan:checkCollision()

	local mx = love.mouse.getX() 
	local my = love.mouse.getY()
	
	
	xan:updateGravity()
	xan:hitRocks()
	xan:checkLand()
	
	
	if mx >= xan.x - xan.drawVars.xo 
		and mx <= xan.x + xan.drawVars.xo then 
		
		xan.mouseBlock = true
		
	else
	
		xan.mouseBlock = false
		
	end
	
		
		


end

function xan:hitRocks()


	
	local pad = 30 -- the place where we hit and cant stand
	

	for i,v in ipairs(rocks) do -- try to hit a list of rockss. A table if you will. 
	
			
		-- this causes issues with top collision. 
		if checkHit(xan, rocks[i]) and xan.x < rocks[i].x and xan.footBlock then
		
			xan.sideBlock = true
			
		elseif checkHit(xan, rocks[i]) and xan.x > rocks[i].x and xan.footBlock then
		
			xan.sideBlock = true
			
		end
			
	-- Unblock When facing away from Rock.
		
		if xan.facing == "left" 
			and checkHit(xan,rocks[i]) 
			and xan.x < rocks[i].x then
			
				xan.sideBlock = false
				
		end
		
		if xan.facing == "right" 
			and checkHit(xan,rocks[i]) 
			and xan.x > rocks[i].x then
			
				xan.sideBlock = false
				
		end 
		
		if xan.canWalk and checkHit(xan,rocks[i]) == false then
		
			xan.sideBlock = false 
		
		end
		
	end

end


function xan:isFacing() -- used when we check a grab so we don't grab rocks that are behind us. 

	for i,v in ipairs(rocks) do

		if xan.facing == "right" and xan.x < rocks[i].x then
			return true
		elseif xan.facing == "left" and xan.x > rocks[i].x then
			return true
		else 
			return false
	
		end
		
	end	

end

-- player methods

-- should I be falling?
function xan:updateGravity()

	if xan.jump == false then 
	
		-- apply gravity.
		xan.y = xan.y + grav

	end
	
	-- keep witin ground Limit ( on screen )
	if xan.y >= groundLevel then 
	
		xan.y = groundLevel
		
	end
	
end	

-- have I landed? if not then I must be landing 
function xan:checkLand()

	-- groundLevel is a good constant for most things. It's bothering the top of rock. 
	
	
	if xan.y >= groundLevel  then
	
		xan.footBlock = true
		xan.canJump = true
		xan.state = "idle"
		xan.canFlip = true 
	
		
	elseif xan.y < groundLevel and xan.jump == false then
	
		xan.footBlock = false
		xan.state = "land"
		
	end	
	
	-- check landing on rocks. 
	for i,v in ipairs(rocks) do
	
		local topRock = rocks[i].y - rocks[i].drawVars.yo
		local rWidth = rocks[i].img:getWidth() * 0.5 
		
		if xan.x > rocks[i].x - rWidth  -- |<--X
			and xan.x < rocks[i].x + rWidth
			and xan.y < rocks[i].y * 0.9 then  -- if xan is above 80 percent of the rock. 
			
			
				xan.footBlock = true
				xan.canJump = true
				xan.state = "idle"
				xan.canFlip = true 
	
		end
	
		
	
	end

	
end 

-- Input Callback
function love.mousereleased(x, y, btn)

	if btn == 'l' then 
	
		xan.jump = false -- we are no longer jumping 
		xan.canJump = false -- we cannot double jump in this game. 
		xan.footBlock = false -- you are always falling from a left click release. 
		xan.canFlip = true
		xan.slam = false
		xan.canSlam = true -- because you need this button to do it. -- consider what modifies this flag. 
		
		xanLand:seek(1)
		xanJump:seek(1) -- we seek the animation so it always starts at the beginning when we release the mouse.
		
	end
	
	
	if btn == 'r' then
	
	-- reset xan state and animation on releases
		xanGrab:seek(1)
		xanKick:seek(1)
		
	-- reset player abilities according to input
		xan.grab = false  
		xan.canKick = true
		xan.canFlip = true
		xan.canWalk = true 
		
	end
	
end 


------------------------------------Player Action Methods 

function xan:Grab()

	xan.state = "grab"
	xan.canFlip = false
	xan.sideBlocked = true
	
	
	gripx = xan.x +(xan.drawVars.sx*60) -- looks pretty good for now. 
	gripy = xan.y - 30 -- it's close.. 
	
	

	for i,v in ipairs(rocks) do 
		if checkHit(xan,rocks[i]) 
			and xan.isFacing(rocks[i]) then
		
			if rocks[i].canGrab then 
		
		-- wait to move the rocks until animation is completed .. then hold animation. 
				if xanGrab:getCurrentFrame() == 4 and rocks[i].state == "grab" then
					xanGrab:seek(4)
					xan.grab = true -- first activate the switch. it can act as a filter against other statements. 
					rocks[i].x = gripx
					rocks[i].y = gripy
				end
			end
		end
	end 
	
end
--------------------------------------------[[
--[[
slam, xan jumps up with the grabbed rock and punches it into the ground
--]]
--------------------------------------------]]
function xan:Slam()

	local smax = xan.jhgt*0.75
	local sSpeed = 60
	xan.canFlip = false
	xan.sideBlocked = true
	
	

	if xan.canSlam then
		xan.state = "slam"
		xan.canJump = true -- this stops the slam from repeating. 
		
		
		for i,v in ipairs(rocks) do
		
			if checkHit(xan,rocks[i]) and xan:isFacing() and xan.slam==false then 
				xanSlam:seek(1)
				rocks[i].x = xan.x + (10 * xan.drawVars.sx)
				rocks[i].y = xan.y - rocks[i].drawVars.xo
				xan.y = xan.y - sSpeed

			end
			
			if xan.y <= smax then
				xanSlam:seek(2)
				xan.slam = true 
				rocks[i].x = xan.x + (10 * xan.drawVars.sx)
				rocks[i].y = xan.y + rocks[i].drawVars.yo
				xan.y = xan.y + sSpeed
			end
			
			if xan.slam == true and xan.footBlock then
				--rocks[i].Slam() -- fake Destroy of rocks. Using the same method that we want in the future. 
				xan.Jump() -- this is a bad place to change state. There has to be a better way. 
			end 
		end
	end
	
end 


--------------------------------------------[[
--[[
Jump, the player jumps.
--------------------------------------------]]

function xan:Jump() 
	
	local jmax = groundLevel - xan.jhgt 
	local topXan = xan.y - xan.drawVars.yo
	
	if xan.canJump then

	-- initial jump accel. constant. 
	-- current accel. 
	-- set current to initial. 
	-- starting jumpspeed. Then subtract dt from jSpd
		xan.footBlock = false 
		xan.canFlip = false 
		xan.jspd = xan.jspd + xan.jacl 
		xan.jump = true -- when we adjust the speed we are jumping
		xan.state = "jump"
		
		-- fall once we reach jump max. 
		if topXan <= jmax then 
			xan.canJump = false
			xan.jump = false
			xan.state = "land"
		end		
		
		-- limit the jump speed 
		if xan.jspd >= xan.jsmx then 
			xan.jspd = xan.jsmx 
		end
		

		xan.y = xan.y - xan.jspd
		xan.x = (xan.x + xan.speed * xan.drawVars.sx) 
	
	else
	
		xan.canFlip = true 
		
	end 
	
	
	-- at the end we update xan y pos with the results from above. 
	-- we need to multiply this by the /limit to get a nice curve. 


end 

function xan:Walk() 

	local speedBoost = 2

	local mx = love.mouse.getX() 
	local my = love.mouse.getY()
	
	if xan.mouseBlock then 

		xan.x = xan.x
		
	end
	
		
	if xan.sideBlock then 
	
		xan.x = xan.x
		xan.state = "idle"
		
	end

		
	if xan.sideBlock == false and xan.footBlock then 
	
		xan.state = "walk"
		xan.x = xan.x +(xan.drawVars.sx * xan.speed) -- move xan. according to facing scale. 
	end
		
end 

function xan:Crouch()

	if xan.footBlock then
		xan.state = "crouch"
	end
	
end

function xan:Kick()

	xan.state = "kick"	
	xan.canFlip = false 
	xan.canWalk = false
		
	if xan.canKick then

		if xanKick:getCurrentFrame(4) and love.mouse.isDown('r') then
		
			xanKick:seek(4)
			xan.kick = false
			xan.canKick = false 
			
		end
	
	end
	
end

