--rock Class. Based on class file. 

require("class.lua")

local boulder = lg.newImage("rock.png")


newRock = class(function(obj, x, y, weight) -- this is the definition of the function that will create the rocks. 

	-- positioning 
	obj.x = x
	obj.y = y

	
	-- game logic variables.
	obj.weight = weight
	obj.state = "sleep" -- this is for fun physics. 
	obj.value = 50 * weight -- bigger rocks. There is more to the point multiplier system. 
	obj.sSpeed = weight * 10

	-- state gates. 
	obj.canFall = true
	obj.canGrab = false  
	obj.canSlide = true
	
	-- check hit edges
	obj.upHit = false
	obj.leftHit = false
	obj.rightHit = false
	obj.downHit = false
	

	-- change art based on weight.
	if obj.weight == 1 then
		obj.img = boulder 
	end
	--elseif other weights. Other images. That's a quick ride. 
	
	
	obj.drawVars = {
		x = obj.x,
		y = obj.y,
		xo = obj.img:getWidth()/2, -- offset is rather important to this system.
		yo = obj.img:getHeight(),
		sx = 1,
		sy = 1,
		rot = 0, -- we can make these more dynamic later. 
	
	}
	

end)


function newRock:update(dt)

	-- Rock input switch. -- you can only be on one path at a time. 
	if checkHit(xan,self) and xan.state == "grab" then
		
		self:checkGrab() 
		--self.state = "grab"
		
	elseif xan.state == "kick" and checkHit(xan,self) then
	
		self.state = "slide"
		self:Slide()
		
	elseif checkHit(xan,self) and self.state == "fall" then
	
		self.state = "sleep"
		

	end
	
	-- Input switch
	if self.state == "slide" then 
		self:Slide()
	elseif self.state == "rest" then
		self.x = self.x
	elseif self.state == "sleep" then 
		self.y = self.y
	end
	

	-- we need a function to separate the rocks. And to organize them. 
	-- may want to combine these functions .. really think about what they do.
	self:updateCollision()	
	
end 

function newRock:draw()

	lg.draw(self.img, self.x, self.y, self.drawVars.rot,self.drawVars.sx, self.drawVars.sy, self.drawVars.xo, self.drawVars.yo)
	--shape at self origin

	-- draw a coloredCircle to denote can Grab
	if self.canGrab == true then 
	
		lg.setColor(200,200,50,150) -- alphaYellow
		lg.circle("fill",self.x, self.y - self.drawVars.yo/2, 20)
	
	elseif self.canSlide == true then 
	
		lg.setColor(50,250,50,150) -- alphagreen
		lg.circle("fill",self.x, self.y - self.drawVars.yo/2, 20)
		
	elseif self.canSlide == false then 
	
		lg.setColor(200,50,50,150) -- alphared
		lg.circle("fill",self.x, self.y - self.drawVars.yo/2, 20)
		
	end
	
	-- draw the state on the rock
	lg.setColor(255,255,55,255) -- back to white. 
	lg.setFont(gtxt)
	lg.print(self.state, self.x - self.drawVars.xo, self.y-32) 
	lg.circle("fill",self.x, self.y, 5)
	
end

function newRock:checkGrab() 	
	
	if checkHit(xan,self) then 

	
			self.state = self.state.." :) "
			self.canGrab = true
			return true
			
		
	end

end




function newRock:updateCollision()



	-- hit the borders of the stage. ( there should be space enough for 7x7 rocks) 
	local selfRight = self.x + self.drawVars.xo
	local selfLeft = self.x - self.drawVars.xo
	local space = 4
	
	local rightEdge = love.graphics.getWidth() - stageBorder
	local leftEdge = stageBorder
	local allow = 4
	
	if selfRight + self.sSpeed > rightEdge then 
		self.x = self.x - space
		
		if self.x <= rightEdge - allow then
		
			self.state = "sleep" -- was rest
			
		end
	end
	
	if selfLeft - self.sSpeed < leftEdge then
		
		self.x = self.x + space
		
		if self.x >= leftEdge + allow then
		
			self.state = "sleep"
		
		end
	end
	

	self:checkLand()
	self:checkBorders() 
	self:keepSpacing()

	-- I want to know how to make the grid spacing look smooth. Ease in to the grid location. 
	-- maybe the rock should behave like xan. we see if it hits then we see what sides are hit. 


end

function newRock:Slide()
		
	-- check canSlide in here?
	for i,v in ipairs(rocks) do
	
		if checkHit(self,rocks[i]) == false then
			if self ~= rocks[i] then
				self.canslide = true
			end
		end
	
	end
	if self.canSlide then 
		la.play(slide)
		
		self.x = self.x + (xan.drawVars.sx * self.sSpeed)
		
	end
		
end

function newRock:Slam() -- will this get rid of that nil?
		
		
		self.state = "slam"
		-- the main fill will be the game state machine so score will be global.
		--addPoints(self.value)
		
end

function newRock:checkBorders()

	local pad = 20

	
	for i,v in ipairs(rocks) do 
	

	local topPad = rocks[i].y - rocks[i].drawVars.yo - pad
	local dwnPad = rocks[i].y + pad
	local leftPad = rocks[i].x - rocks[i].drawVars.xo - pad
	local rightPad = rocks[i].x + rocks[i].drawVars.xo + pad

		if self ~= rocks[i] then 
		
			if checkHit(self,rocks[i]) then  -- are we hitting the edges?
			
			
		
			-- same idea. Better Switch. 
			
			---[[
				if self.y <= topPad  then
				
					self.upHit = true
					self.state= self.state.."-T"
					
				else
				
					self.leftHit = false 
					
				end
				
				
				end
				
				if self.y >= dwnPad then
					
					self.downHit = true 
					self.state= self.state.."-D"
				
				else			
				
					self.downHit = false 
					
				end
				
				if self.y >= leftPad then -- my leftside is hit
					
					self.leftHit = true 
					self.state= self.state.."-L"
		
				else
				
					self.leftHit = false 
					
				end
				
				if self.y <= rightPad then
					
					self.rightHit = true 
					self.state= self.state.."-R"
					
				else
							
					self.rightHit = false 
					
				end
				
				
				
			end

			
			
		end
end
	

function newRock:checkLand()

	-- update self gravity.
	if self.state == "sleep" or "rest" and checkHit(xan,self) == false then

		self.state = "fall"

	end 
	
	if self.state == "fall" and self.y < groundLevel then
		self.y = self.y + grav
	elseif self.y >= groundLevel then
		self.state = "sleep"
		self.y = groundLevel
	end
	

end 

function newRock:keepSpacing()

	-- the goal here is to make the rocks have a look at eachother and separate themselves. 
	
	--keep the self on stage. we can use the rock edges to hit other rocks. 
	local edgeRight = self.x + self.drawVars.xo
	local edgeLeft = self.x - self.drawVars.xo
	local edgeUp = self.y - self.drawVars.yo
	local edgeDown = self.y -- we adjust the origin to the bottom. Everything has a foot in this game. 
	
	-- and we can set a cell size and a spread speed anti friction if you will.  Part of what makes games fun. 
	local spread = 8 -- pace at which we punish the rocks. 
	local dist = 32 -- the space that should be between rock origins. 
		
	-- keep on screen. X AXIS
	if self.x + self.sSpeed > love.graphics.getWidth() then 
	
		self.x = love.graphics.getWidth() - stageBorder
		self.state = "sleep"
	
	elseif self.x + self.sSpeed < 0 + stageBorder then 
	
		self.x = 0 + stageBorder
		self.state = "sleep"
	
	end
	
	--land on top
	if checkHit(xan,self) and self.y < xan.y then 
	
		
	
	end 
	
	-- hit xan in the foot. Become a good ground. ( the top rock will be able to grab. ) 
	if checkHit(xan, self) and xan.y <= edgeUp then 
		 -- this is an issue... this is where the mysterious fly comes from.  
		xan.y = edgeUp - grav
		xan.footBlock = true
		xan.canJump = true
		xan.jump = false
		
	end
	

	
	local rPad = 20
	---[[
	for i,v in ipairs(rocks) do 

		local rockRight = rocks[i].x + rocks[i].drawVars.xo
		local rockLeft = rocks[i].x - rocks[i].drawVars.xo
		local rockUp = rocks[i].y - rocks[i].drawVars.yo
		local rockDown = rocks[i].y 	
		
		
		if checkHit(self,rocks[i]) then
			
			if rocks[i] ~= self then
			
				if edgeRight + self.sSpeed >= rockLeft then 
				
					self.canSlide = false
				
				elseif edgeLeft - self.sSpeed <= rockRight then
				
					self.canSlide = false
				end
				
				if self.x <= rocks[i].x - rPad and self.y > rockUp then -- if the self is on the left side of the rock when they collide. 
					
					self.x = self.x - spread
			
				elseif self.x >= rocks[i].x + rPad and self.y > rockUp then -- is to the right side. not on top. 
			
					self.x = self.x + spread		
					
				elseif self.y <= rocks[i].y  then
					-- could use to substitute with is above. 
					self.y = self.y  - grav			
					
				end
				
			end		
			
		end
		
	end 
	--]]
	
	-- this is a suggested method for the grid. ( it has some flaws. But good spacing is hard to make fun. 
	local snapX = math.abs(self.x/7) * 7
	local snapY = math.abs(self.y/7) * 7  -- could be substituded for global gridW and gridH
	
	local rx = math.floor(snapX)
	local ry = math.floor(snapY)
	
	self.x = rx
	self.y = ry 

end 


